###################################################
### chunk number 1: 
###################################################
#line 85 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
library("VGAM")
ps.options(pointsize = 12)
options(width = 72, digits = 4)
options(SweaveHooks = list(fig = function() par(las = 1)))
options(prompt = "R> ", continue = "+")


###################################################
### chunk number 2: 
###################################################
#line 614 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
pneumo <- transform(pneumo, let=log(exposure.time))
fit <- vgam(cbind(normal, mild, severe) ~ s(let, df=2),
            cumulative(reverse=TRUE, parallel=TRUE), pneumo)


###################################################
### chunk number 3: 
###################################################
#line 900 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
journal <- c("Biometrika", "Comm.Statist", "JASA", "JRSS-B")
squaremat <- matrix(c(NA, 33, 320, 284,   730, NA, 813, 276,
                      498, 68, NA, 325,   221, 17, 142, NA), 4, 4)
dimnames(squaremat) <- list(winner = journal, loser = journal)


###################################################
### chunk number 4: 
###################################################
#line 1005 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
abodat <- data.frame(A = 725, B = 258, AB = 72, O = 1073)
fit <- vglm(cbind(A, B, AB, O) ~ 1, ABO, abodat)
coef(fit, matrix = TRUE)
Coef(fit) # Estimated pA and pB


###################################################
### chunk number 5: 
###################################################
#line 1315 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
head(wffc.nc, 5)


###################################################
### chunk number 6: 
###################################################
#line 1325 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
fnc <- transform(wffc.nc,
                 finame = factor(iname),
                 fsector = factor(sector),
                 fday = factor(ceiling(session / 2)),
                 mornaft = 1 - (session %% 2),
                 fbeatboat = factor(beatboat))

fnc <- fnc[with(fnc, !is.element(comid, c(99,72,80,93,45,71,97,78))),] 
fnc <- transform(fnc,
                ordnum = ifelse(numbers <= 02, "few",
                         ifelse(numbers <= 10, "more", "most")))
fnc$ordnum <- ordered(fnc$ordnum, levels = c("few", "more", "most"))


###################################################
### chunk number 7: 
###################################################
#line 1342 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
with(fnc, table(ordnum))


###################################################
### chunk number 8: 
###################################################
#line 1350 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
fit.pom <- vglm(ordnum ~
          fsector +
          mornaft +
          fday +
          finame,
          family = cumulative(parallel = TRUE, reverse = TRUE),
          data = fnc)


###################################################
### chunk number 9: 
###################################################
#line 1369 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
head(fit.pom@y, 3)
colSums(fit.pom@y)


###################################################
### chunk number 10: 
###################################################
#line 1382 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
head(coef(fit.pom, matrix = TRUE), 10)
#head(summary(fit.pom)@coef3, 10) # Old now since 0.7-10 is nicer


###################################################
### chunk number 11: 
###################################################
#line 1388 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
head(coef(summary(fit.pom)), 10)


###################################################
### chunk number 12: 
###################################################
#line 1435 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
fit.ppom <- vglm(ordnum ~
          fsector +
          mornaft +
          fday +
          finame,
          cumulative(parallel = FALSE ~ 1 + mornaft, reverse=TRUE),
          data = fnc)
head(coef(fit.ppom, matrix = TRUE),  8)


###################################################
### chunk number 13: 
###################################################
#line 1448 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
pchisq(deviance(fit.pom) - deviance(fit.ppom),
       df = df.residual(fit.pom) - df.residual(fit.ppom), lower.tail=FALSE)


###################################################
### chunk number 14: 
###################################################
#line 1457 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
fit2.ppom <- vglm(ordnum ~
          fsector +
          mornaft +
          fday +
          finame,
          family = cumulative(parallel = FALSE ~ 1 + fday, reverse = TRUE),
          data=fnc)
head(coef(fit2.ppom, matrix = TRUE), 8)


###################################################
### chunk number 15: 
###################################################
#line 1470 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
head(fitted(fit2.ppom), 3)


###################################################
### chunk number 16: 
###################################################
#line 1476 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
head(predict(fit2.ppom), 3)


###################################################
### chunk number 17: 
###################################################
#line 1481 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
dim(model.matrix(fit2.ppom, type = "lm"))
dim(model.matrix(fit2.ppom, type = "vlm"))


###################################################
### chunk number 18: 
###################################################
#line 1487 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
constraints(fit2.ppom)[c(1, 2, 5, 6)]


###################################################
### chunk number 19: 
###################################################
#line 1525 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
head(nzmarital, 4)
summary(nzmarital)


###################################################
### chunk number 20: 
###################################################
#line 1530 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
fit.ms <- vgam(mstatus ~ s(age, df = 3), multinomial(refLevel=2),
               data = nzmarital)


###################################################
### chunk number 21: 
###################################################
#line 1536 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
head(fit.ms@y, 4)
colSums(fit.ms@y)


###################################################
### chunk number 22: 
###################################################
#line 1547 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
# Plot output
mycol <- c("red","darkgreen","blue")
 par(mfrow=c(2,2))
plot(fit.ms, se=TRUE, scale=12,
         lcol=mycol, scol=mycol)

# Plot output overlayed
#par(mfrow=c(1,1))
plot(fit.ms, se=TRUE, scale=12,
         overlay=TRUE,
         llwd=2,
         lcol=mycol, scol=mycol)


###################################################
### chunk number 23: 
###################################################
#line 1602 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
# Plot output
mycol <- c("red","darkgreen","blue")
 par(mfrow=c(2,2))
 par(mar=c(4.2,4.0,1.2,2.2)+0.1)
plot(fit.ms, se=TRUE, scale=12,
         lcol=mycol, scol=mycol)

# Plot output overlaid
#par(mfrow=c(1,1))
plot(fit.ms, se=TRUE, scale=12,
         overlay=TRUE,
         llwd=2,
         lcol=mycol, scol=mycol)


###################################################
### chunk number 24: 
###################################################
#line 1635 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
plot(fit.ms, deriv=1, lcol=mycol, scale=0.3)


###################################################
### chunk number 25: 
###################################################
#line 1645 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
# Plot output
 par(mfrow=c(1,3))
 par(mar=c(4.5,4.0,0.2,2.2)+0.1)
plot(fit.ms, deriv=1, lcol=mycol, scale=0.3)


###################################################
### chunk number 26: 
###################################################
#line 1672 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
foo <- function(x, elbow=50)
    poly(pmin(x, elbow), 2)

clist <- list("(Intercept)" = diag(3),
             "poly(age, 2)" = rbind(1, 0, 0),
             "foo(age)" = rbind(0, 1, 0),
             "age" = rbind(0, 0, 1))
fit2.ms <-
    vglm(mstatus ~ poly(age, 2) + foo(age) + age,
         family = multinomial(refLevel=2),
         constraints=clist,
         data=nzmarital)


###################################################
### chunk number 27: 
###################################################
#line 1687 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
coef(fit2.ms, matrix = TRUE)


###################################################
### chunk number 28: 
###################################################
#line 1692 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
par(mfrow=c(2,2))
plotvgam(fit2.ms, se=TRUE, scale=12,
         lcol=mycol[1], scol=mycol[1], which.term=1)
plotvgam(fit2.ms, se=TRUE, scale=12,
         lcol=mycol[2], scol=mycol[2], which.term=2)
plotvgam(fit2.ms, se=TRUE, scale=12,
         lcol=mycol[3], scol=mycol[3], which.term=3)


###################################################
### chunk number 29: 
###################################################
#line 1710 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
# Plot output
par(mfrow=c(2,2))
 par(mar=c(4.5,4.0,1.2,2.2)+0.1)
plotvgam(fit2.ms, se=TRUE, scale=12,
         lcol=mycol[1], scol=mycol[1], which.term=1)
plotvgam(fit2.ms, se=TRUE, scale=12,
         lcol=mycol[2], scol=mycol[2], which.term=2)
plotvgam(fit2.ms, se=TRUE, scale=12,
         lcol=mycol[3], scol=mycol[3], which.term=3)


###################################################
### chunk number 30: 
###################################################
#line 1737 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
deviance(fit.ms) - deviance(fit2.ms)


###################################################
### chunk number 31: 
###################################################
#line 1744 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
(dfdiff <- df.residual(fit2.ms) - df.residual(fit.ms))


###################################################
### chunk number 32: 
###################################################
#line 1748 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
1-pchisq(deviance(fit.ms) - deviance(fit2.ms), df=dfdiff)


###################################################
### chunk number 33: 
###################################################
#line 1762 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
ooo <- with(nzmarital, order(age))
with(nzmarital, matplot(age[ooo], fitted(fit.ms)[ooo,],
     type="l", las=1, lwd=2, ylim=0:1,
     ylab="Fitted probabilities",
     xlab="Age", # main="Marital status amongst NZ Male Europeans",
     col=c(mycol[1], "black", mycol[-1])))
legend(x=52.5, y=0.62, # x="topright",
       col=c(mycol[1], "black", mycol[-1]),
       lty=1:4,
       legend=colnames(fit.ms@y), lwd=2)
abline(v=seq(10,90,by=5), h=seq(0,1,by=0.1), col="gray", lty="dashed")


###################################################
### chunk number 34: 
###################################################
#line 1788 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
 par(mfrow=c(1,1))
 par(mar=c(4.5,4.0,0.2,0.2)+0.1)
ooo <- with(nzmarital, order(age))
with(nzmarital, matplot(age[ooo], fitted(fit.ms)[ooo,],
     type="l", las=1, lwd=2, ylim=0:1,
     ylab="Fitted probabilities",
     xlab="Age",
     col=c(mycol[1], "black", mycol[-1])))
legend(x=52.5, y=0.62,
       col=c(mycol[1], "black", mycol[-1]),
       lty=1:4,
       legend=colnames(fit.ms@y), lwd=2.1)
abline(v=seq(10,90,by=5), h=seq(0,1,by=0.1), col="gray", lty="dashed")


###################################################
### chunk number 35: 
###################################################
#line 1835 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
# Scale the variables? Yes; the Anderson (1984) paper did (see his Table 6).
head(backPain, 4)
summary(backPain)
backPain <- transform(backPain, sx1 = -scale(x1), sx2 = -scale(x2), sx3 = -scale(x3))


###################################################
### chunk number 36: 
###################################################
#line 1843 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
bp.rrmlm1 <- rrvglm(pain ~ sx1 + sx2 + sx3, multinomial, backPain)


###################################################
### chunk number 37: 
###################################################
#line 1847 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
Coef(bp.rrmlm1)


###################################################
### chunk number 38: 
###################################################
#line 1876 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
set.seed(123)


###################################################
### chunk number 39: 
###################################################
#line 1880 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
bp.rrmlm2 <- rrvglm(pain ~ sx1 + sx2 + sx3, multinomial, backPain, Rank=2,
                   Corner=FALSE, Uncor=TRUE)


###################################################
### chunk number 40: 
###################################################
#line 1890 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
biplot(bp.rrmlm2, Acol="blue", Ccol="darkgreen", scores=TRUE,
#      xlim=c(-1,6), ylim=c(-1.2,4), # Use this if not scaled
       xlim=c(-4.5,2.2), ylim=c(-2.2, 2.2), # Use this if scaled
       chull=TRUE, clty=2, ccol="blue")


###################################################
### chunk number 41: 
###################################################
#line 1926 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
# Plot output
 par(mfrow=c(1,1))
 par(mar=c(4.5,4.0,0.2,2.2)+0.1)

biplot(bp.rrmlm2, Acol="blue", Ccol="darkgreen", scores=TRUE,
#      xlim=c(-1,6), ylim=c(-1.2,4),  # Use this if not scaled
       xlim=c(-4.5,2.2), ylim=c(-2.2, 2.2),  # Use this if scaled
       chull=TRUE, clty=2, ccol="blue")


###################################################
### chunk number 42: 
###################################################
#line 2048 "/build/buildd-r-cran-vgam_0.8-2-1-mips-mxp9Wx/r-cran-vgam-0.8-2/inst/doc/categoricalVGAM.Rnw"
iam(NA, NA, M = 4, both = TRUE, diag = TRUE)


